﻿Imports System.Runtime.InteropServices, System.IO, Microsoft.Win32
Public NotInheritable Class Wallpaper
    Const SPI_SETDESKWALLPAPER As Integer = 20
    Const SPIF_UPDATEINIFILE As Integer = &H1
    Const SPIF_SENDWININICHANGE As Integer = &H2
    <DllImport("user32.dll", CharSet:=CharSet.Auto)> _
    Shared Function SystemParametersInfo(ByVal uAction As Integer, ByVal uParam As Integer, ByVal lpvParam As String, ByVal fuWinIni As Integer) As Integer
    End Function
    Public Enum Style As Integer
        Tiled
        Centered
        Stretched
    End Enum
    Public Shared Sub [Set](ByVal uri As Uri, ByVal style As Style)
        Dim s As System.IO.Stream = New System.Net.WebClient().OpenRead(uri.ToString())
        Dim img As System.Drawing.Image = System.Drawing.Image.FromStream(s)
        Dim tempPath As String = Path.Combine(Path.GetTempPath(), "wallpaper.bmp")
        img.Save(tempPath, System.Drawing.Imaging.ImageFormat.Bmp)
        Dim key As RegistryKey = Registry.CurrentUser.OpenSubKey("Control Panel\Desktop", True)
        If style = style.Stretched Then
            key.SetValue("WallpaperStyle", 2.ToString())
            key.SetValue("TileWallpaper", 0.ToString())
        End If
        If style = style.Centered Then
            key.SetValue("WallpaperStyle", 1.ToString())
            key.SetValue("TileWallpaper", 0.ToString())
        End If
        If style = style.Tiled Then
            key.SetValue("WallpaperStyle", 1.ToString())
            key.SetValue("TileWallpaper", 1.ToString())
        End If
        SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, tempPath, SPIF_UPDATEINIFILE Or SPIF_SENDWININICHANGE)
    End Sub
End Class
